#include <bits/stdc++.h>

using namespace std;

typedef long long LL;
typedef pair<LL,LL> pll;
const int MAXN = 200010;
const LL INF = 1e16;
int N, M;
LL x[MAXN], y[MAXN];

LL cost(LL up, LL down) {
    if (up < down) return 0;
    return up - down + min(abs(up), abs(down));
}

int cover(LL left_ma, LL left_mi, LL right_ma, LL right_mi) {
    if (right_ma > left_ma && right_mi < left_mi) return 1;
    if (right_ma <= left_ma && right_mi < left_mi) return 2;
    if (right_ma > left_ma && right_mi >= left_mi) return 3;
    return 4;
}

LL calc() {
    vector<pll> neg, pos;
    for (int i=1;i<=N;i++) {
        if (x[i] < 0) neg.push_back(pll(x[i], y[i]));
        if (x[i] > 0) pos.push_back(pll(x[i], y[i]));
    }
    int N1 = neg.size(), N2 = pos.size();
    if (N1 == 0 && N2 == 0) return 0;
    LL left_mi = INF, left_ma = -INF;
    vector<LL>ma(N2 + 1, -INF), mi(N2 + 1, INF), py(N2 + 1), px(N2 + 1);
    sort(neg.begin(), neg.end());
    sort(pos.begin(), pos.end());
    for (int i=0;i<N2;i++) {
        px[i] = pos[i].first;
        py[i] = pos[i].second;
    }
    px[N2] = 4 * INF;
    
    /*
    printf("%d %d\n",N1,N2);
    puts("neg:");
    for (auto t:neg) printf("%d %d\n",t.first,t.second);
    puts("pos");
    for (auto t:pos) printf("%d %d\n",t.first,t.second);
    */
    if (!N1) return INF;
    if (!N2) {
        LL ret = INF;
        for (int i=0;i<N1;i++) {
            ret = min(ret, abs(neg[i].first) + cost(left_ma, left_mi));
            left_ma = max(left_ma, neg[i].second);
            left_mi = min(left_mi, neg[i].second);
        }
        ret = min(ret, cost(left_ma, left_mi));
        return ret;
    }
    for (int i=N2-1;i>=0;i--) {
        ma[i] = max(ma[i + 1], pos[i].second);
        mi[i] = min(mi[i + 1], pos[i].second);
    }
    multiset<LL>s1, s2, s3;
    int node1, node2;
    LL ret = INF;
    LL all_covered_min_x = INF;
    
    // left, {up, down}
    for (int i=0;i<N1;i++) {
        LL tmp;
        tmp = abs(neg[i].first) + cost(max(left_ma, ma[0]), min(left_mi, mi[0]));
        ret = min(ret, tmp);
        left_mi = min(left_mi, neg[i].second);
        left_ma = max(left_ma, neg[i].second);
    }
    ret = min(ret, cost(max(left_ma, ma[0]), min(left_mi, mi[0])));


    // left, right, {up, down}
    LL last_left_mi, last_left_ma;

    // 1. max{left_ma, ma[i]} - min{left_mi, mi[i]} + abs{max(left_ma, ma[i])} + px[i - 1]
    // s1          s2, s3          all_covered
    // [1, node1), [node1, node2), [node2, N2 + 1)
    // The id of {i}
    last_left_mi = INF;
    last_left_ma = -INF;
    left_mi = INF;
    left_ma = -INF;
    node1 = node2 = N2; // N2 is all_covered
    all_covered_min_x = px[N2 - 1];
    s1.clear();
    s2.clear();
    s3.clear();
    ret = min(ret, 2LL * (-neg[0].first) + px[N2 - 1]);
    for (int i=1;i<node2;i++) {
        s1.insert(ma[i] - mi[i] + abs(ma[i]) + px[i - 1]);
    }
    if (!s1.empty()) {
        LL tmp = 2LL * (-neg[0].first) + (*s1.begin());
        ret = min(ret, tmp);
    }
    for (int i=0;i<N1;i++) {
        left_mi = min(last_left_mi, neg[i].second);
        left_ma = max(last_left_ma, neg[i].second);
        int new_cover = 0;
        while(node1 > 1) {
            int new_cover_type = cover(left_ma, left_mi, ma[node1 - 1], mi[node1 - 1]);
            if (new_cover_type == 1) break;
            int last_cover_type = cover(last_left_ma, last_left_mi, ma[node1 - 1], mi[node1 - 1]);
            assert(last_cover_type == 1);
            node1--;
            // avoid double delete
            if (new_cover_type != 4) s1.erase(s1.find(ma[node1] - mi[node1] + abs(ma[node1]) + px[node1 - 1]));
            if (new_cover_type == 2) s2.insert(-mi[node1] + px[node1 - 1]);
            if (new_cover_type == 3) s3.insert(ma[node1] + abs(ma[node1]) + px[node1 - 1]);
        }
        while(node2 > 1) {
            int new_cover_type = cover(left_ma, left_mi, ma[node2 - 1], mi[node2 - 1]);
            if (new_cover_type != 4) break;
            int last_cover_type = cover(last_left_ma, last_left_mi, ma[node2 - 1], mi[node2 - 1]);
            assert(last_cover_type != 4);
            node2--;
            assert(all_covered_min_x >= px[node2 - 1]);
            all_covered_min_x = px[node2 - 1];
            if (last_cover_type == 1) s1.erase(s1.find(ma[node2] - mi[node2] + abs(ma[node2]) + px[node2 - 1]));
            if (last_cover_type == 2) s2.erase(s2.find(-mi[node2] + px[node2 - 1]));
            if (last_cover_type == 3) s3.erase(s3.find(ma[node2] + abs(ma[node2]) + px[node2 - 1]));
        } 
        LL tmp = INF;
        LL left_dist = (i == N1 - 1 ? 0 : -neg[i + 1].first);
        if (!s1.empty()) {
            tmp = min(tmp, 2LL * left_dist + *s1.begin());
        }
        if (!s2.empty()) {
            tmp = min(tmp, 2LL * left_dist + *s2.begin() + left_ma + abs(left_ma));
        }
        if (!s3.empty()) {
            tmp = min(tmp, 2LL * left_dist + *s3.begin() - left_mi);
        }
        tmp = min(tmp, 2LL * left_dist + all_covered_min_x + left_ma - left_mi + abs(left_ma));
        ret = min(ret, tmp);

        assert(node2 >= node1);
        last_left_mi = left_mi;
        last_left_ma = left_ma;
    }

    // 2. max{left_ma, ma[i]} - min{left_mi, mi[i]} + abs(min(left_ma, mi[i]}) + px[i - 1]
    // s1          s2, s3          all_covered
    // [1, node1), [node1, node2), [node2, N2 + 1)
    // The id of {i}

    last_left_mi = INF;
    last_left_ma = -INF;
    left_mi = INF;
    left_ma = -INF;
    node1 = node2 = N2; // N2 is all_covered
    all_covered_min_x = px[N2 - 1];
    
    s1.clear();
    s2.clear();
    s3.clear();
    for (int i=1;i<node2;i++) {
        s1.insert(ma[i] - mi[i] + abs(mi[i]) + px[i - 1]);
    }
    if (!s1.empty()) {
        LL tmp = 2LL * (-neg[0].first) + (*s1.begin());
        ret = min(ret, tmp);
    }
    for (int i=0;i<N1;i++) {
        left_mi = min(last_left_mi, neg[i].second);
        left_ma = max(last_left_ma, neg[i].second);
        int new_cover = 0;
        while(node1 > 1) {
            int new_cover_type = cover(left_ma, left_mi, ma[node1 - 1], mi[node1 - 1]);
            if (new_cover_type == 1) break;
            int last_cover_type = cover(last_left_ma, last_left_mi, ma[node1 - 1], mi[node1 - 1]);
            assert(last_cover_type == 1);
            node1--;
            if (new_cover_type != 4) s1.erase(s1.find(ma[node1] - mi[node1] + abs(mi[node1]) + px[node1 - 1]));
            if (new_cover_type == 2) s2.insert(-mi[node1] + px[node1 - 1] + abs(mi[node1]));
            if (new_cover_type == 3) s3.insert(ma[node1] + px[node1 - 1]);
        }
        while(node2 > 1) {
            int new_cover_type = cover(left_ma, left_mi, ma[node2 - 1], mi[node2 - 1]);
            if (new_cover_type != 4) break;
            int last_cover_type = cover(last_left_ma, last_left_mi, ma[node2 - 1], mi[node2 - 1]);
            assert(last_cover_type != 4);
            node2--;
            assert(all_covered_min_x >= px[node2 - 1]);
            all_covered_min_x = px[node2 - 1];
            if (last_cover_type == 1) s1.erase(s1.find(ma[node2] - mi[node2] + abs(mi[node2]) + px[node2 - 1]));
            if (last_cover_type == 2) s2.erase(s2.find(-mi[node2] + px[node2 - 1] + abs(mi[node2])));
            if (last_cover_type == 3) s3.erase(s3.find(ma[node2] + px[node2 - 1]));
        } 
        LL tmp = INF;
        LL left_dist = (i == N1 - 1 ? 0 : -neg[i + 1].first);
        if (!s1.empty()) {
            tmp = min(tmp, 2LL * left_dist + *s1.begin());
        }
        if (!s2.empty()) {
            tmp = min(tmp, 2LL * left_dist + *s2.begin() + left_ma);
        }
        if (!s3.empty()) {
            tmp = min(tmp, 2LL * left_dist + *s3.begin() - left_mi + abs(left_mi));
        }
        tmp = min(tmp, 2LL * left_dist + all_covered_min_x + left_ma - left_mi + abs(left_mi));
        ret = min(ret, tmp);

        assert(node2 >= node1);
        last_left_mi = left_mi;
        last_left_ma = left_ma;
    }
    return ret;
}

void solve(int Case) {
    scanf("%d",&N);
    for (int i=1;i<=N;i++) {
        scanf("%lld%lld",&x[i],&y[i]);
    }
    LL ans = calc();
    
    for (int i=1;i<=N;i++) x[i] = -x[i];
    ans = min(ans, calc());
    for (int i=1;i<=N;i++) swap(x[i], y[i]);
    ans = min(ans, calc());
    for (int i=1;i<=N;i++) x[i] = -x[i];
    ans = min(ans, calc());
    
    printf("%lld\n",ans);
}

int main() {
    int T = 1;
    scanf("%d",&T);
    for (int Case=1;Case<=T;Case++) {
        solve(Case);
    }    
}