#include <cstdio>
#include <cstring>
#include <vector>
#include <set>
#include <cassert>
using namespace std;

int tcase,n,m;

vector<int> e[100010];
set<int> t[100010];
int deg[100010];
bool vis[100010];

int root[100010];

int findroot(int nod)
{
    if(root[nod] != nod) root[nod] = findroot(root[nod]);
    return root[nod];
}

void dfs1(int sn,int fa)
{
    vis[sn] = true;
    for(int fn : e[sn])
    {
        if(vis[fn]) continue;
        dfs1(fn,sn);
        t[sn].insert(fn); t[fn].insert(sn);
        deg[sn]++; deg[fn]++;
    }
}

void dfs2(int sn,int fa)
{
    for(int fn : t[sn])
    {
        if(fn == fa) continue;
        dfs2(fn,sn);
        root[fn] = (fa ? sn : fn);
    }
}

void gao(int r,int a,int sn,int b,int fn)
{
    assert(t[a].find(r) != t[a].end());
    t[a].erase(r); t[r].erase(a);
    deg[a]--; deg[r]--;
    t[sn].insert(fn); t[fn].insert(sn);
    deg[sn]++; deg[fn]++;
    root[a] = b;
}

void print(int sn,int fa)
{
    for(int fn : t[sn])
    {
        if(fn == fa) continue;
        printf("%d %d\n",sn,fn);
        print(fn,sn);
    }
}

void assertNo(int r)
{
    for(int i=1;i<=n;i++) root[i] = i;
    for(int sn=1;sn<=n;sn++) if(sn != r)
        for(int fn : e[sn]) if(fn != r)
        {
            int a = findroot(sn), b = findroot(fn);
            if(a != b) root[a] = b;
        }

    int cnt = 0;
    for(int i=1;i<=n;i++) if(i != r) cnt += (findroot(i) == i);
    assert(cnt > n/2);
}

int main()
{
    scanf("%d",&tcase);
    while(tcase--)
    {
        scanf("%d%d",&n,&m);
        for(int i=1;i<=n;i++) e[i].clear(), t[i].clear();
        memset(vis,0,sizeof(bool)*(n+3)); memset(deg,0,sizeof(int)*(n+3));

        for(int i=1;i<=m;i++)
        {
            int sn,fn;
            scanf("%d%d",&sn,&fn);
            e[sn].push_back(fn); e[fn].push_back(sn);
        }

        if(n == 2) { printf("Yes\n1 2\n"); continue; }
        if(n == 3) { printf("No\n"); continue; }

        dfs1(1,0);
        int r;
        for(r=1;r<=n;r++) if(deg[r]*2 > n) goto STEP2;
        printf("Yes\n"); print(1,0); continue;

        STEP2:
        dfs2(r,0);
        for(int sn=1;sn<=n;sn++) if(sn != r) for(int fn : e[sn]) if(fn != r)
        {
            int a = findroot(sn), b = findroot(fn);
            if(a == b) continue;
            if((deg[sn]+1)*2 > n) assert(a == sn), gao(r,a,sn,b,fn);
            else gao(r,b,fn,a,sn);
            if(deg[r]*2 <= n) goto OK;
        }
        assertNo(r);
        printf("No\n"); continue;
        OK: printf("Yes\n");
        print(r,0);
    }
    return 0;
}
