#include <stdio.h>
#include <assert.h>
#include <algorithm>
#include <vector>
using namespace std;
#define N (310)
#define eps (1e-15)
#define PB push_back
#define PB_TRI(a,b,c,d,e,f) s.PB(Seg(a, b, c, d));s.PB(Seg(c, d, e, f));s.PB(Seg(e, f, a, b))
#define delta (2.0*m*vy)
#define cross(a,b,x,y) (sgn((a)*(y)-(b)*(x)))
int sgn(double x) {
    if (x < -eps) {
        return -1;
    } else if (x > eps) {
        return 1;
    }
    return 0;
}
int vst[N], n, m, cnt;
struct Seg {
    double x, y, x0, y0;
    Seg(double x, double y, double x0, double y0): x(x), y(y), x0(x0), y0(y0) {}
    int intersect(const Seg &s) {
        if (ispoint() || s.ispoint()) {
            return false;
        }
        if (max(x, x0) < min(s.x, s.x0) || max(s.x, s.x0) < min(x, x0) || max(y, y0) < min(s.y, s.y0) || max(s.y, s.y0) < min(y, y0)) return false;
        return cross(s.x-x, s.y-y, s.x0-x, s.y0-y)*cross(s.x-x0, s.y-y0, s.x0-x0, s.y0-y0) <= 0 && 
            cross(x-s.x, y-s.y, x0-s.x, y0-s.y)*cross(x-s.x0, y-s.y0, x0-s.x0, y0-s.y0) <= 0;
    }
    int ispoint() const {
        return x == x0 && y == y0;
    }
};

struct Poly {
    int x, y, x1, y1, l, vy;
    double a, b, a1, b1;
    vector<Seg> s;

    void read() {
        scanf("%d%d%d%d", &x, &y, &x1, &y1);
    }
    void cal(double vx, int vy) {
        a = x * vy + y * vx;
        b = y * vx - x * vy;
        a1 = x1 * vy + y1 * vx;
        b1 = y1 * vx - x1 * vy;
        if (a > a1) {
            swap(a, a1);
            swap(b, b1);
            swap(x, x1);
            swap(y, y1);
        }
        s.clear();
        if (x == -m) {
            if (b1 < b) {
                PB_TRI(a1, b1, a1, a1+delta, b1-delta, b1);
            } else {
                PB_TRI(a1, b1, a1, a1+delta, a, b);
            }
        } else if (x1 == -m) {
            PB_TRI(a, b, a1, b1, b-delta, b);
        }
        if (x1 == m) {
            if (b > b1) {
                PB_TRI(a, b, a, a-delta, b+delta, b);
            } else {
                PB_TRI(a, b, a, a-delta, a1, b1);
            }
        } else if (x == m) {
            PB_TRI(a1, b1, a, b, b1+delta, b1);
        }
        if (s.size() <= 0) {
            if (b <= b1) {
                s.PB(Seg(a, b, a1, b1));
            } else {
                s.PB(Seg(a, b, a, b1));
                s.PB(Seg(a, b1, a1, b1));
                s.PB(Seg(a1, b1, a1, b));
                s.PB(Seg(a1, b, a, b));
            }
        }
    }
    void merge(const Poly &p) {
        if (p.b <= p.b1) {
            s.PB(Seg(p.b-delta, p.b, p.a, p.b));
            s.PB(Seg(p.a, p.b, p.a1, p.b1));
            s.PB(Seg(p.a1, p.b1, p.a1, p.a1+delta));
        } else {
            s.PB(Seg(p.b1-delta, p.b1, p.a1, p.b1));
            s.PB(Seg(p.a1, p.b1, p.a1, p.a1+delta));
        }
    }
    void clear() {
        s.clear();
    }
    int intersect(const Poly &p) {
        for (auto s0: s) {
            for (auto s1: p.s) {
                if (s0.intersect(s1)) {
                    return 1;
                }
            }
        }
        return 0;
    }
} s[N], un;
int dfs(int x) {
    vst[x] = cnt;
    if (s[x].x == m || s[x].x1 == m) {
        return 1;
    }
    un.merge(s[x]);
    for (int i = 1; i <= n; ++i) {
        if (vst[i] != cnt && un.intersect(s[i])) {
            if (dfs(i)) {
                return 1;
            }
        }
    }
    return 0;
}
int main() {
    int vy;
    scanf("%d%d%d", &n, &m, &vy);
    double l = 0.0, r = 2e5+1;
    for (int i = 1; i <= n; ++i) {
        s[i].read();
        if (s[i].x == -m && s[i].x1 == m || s[i].x1 == -m && s[i].x == m) {
            r = -1;
        }
    }
    double lastl = l-1, lastr = r+1;
    while (l + eps < r) {
        double vx = (l + r) / 2.0;
        for (int i = 1; i <= n; ++i) {
            s[i].cal(vx, vy);
        }
        int block = 0;
        cnt++;
        for (int i = 1; i <= n; ++i) {
            if ((s[i].x == -m || s[i].x1 == -m) && vst[i] != cnt) {
                un.clear();
                un.vy = vy;
                if (dfs(i)) {
                    block = 1;
                    break;
                }
            }
        }
        if (block) {
            l = vx;
        } else {
            r = vx;
        }
        if (lastl == l && lastr == r) {
            break;
        }
        // break;
        lastl = l, lastr = r;
    }
    if (r > -0.5 && r < 2e5+0.5) {
        printf("%0.15lf\n", l);
    } else {
        printf("-1\n");
    }
}