#include <cstdio>
#include <vector>
#include <cstring>

using i64 = long long;

const int N = 2000 + 10;

std::vector<int> edges[N];
i64 dp[N][N][2], hp[N];
i64 f[N], g[N];
int size[N];

void upd(i64 &x, i64 y) {
  if (x == -1 || x < y) x = y;
}

void dfs(int u) {
  memset(dp[u], -1, sizeof(dp[u]));
  size[u] = 1;
  i64 delta = hp[u];
  for (auto &v: edges[u]) {
    dfs(v);
    size[u] += size[v];
    delta += hp[v];
  }
  for (int e = 0; e < 2; ++e) {
    f[0] = 0;
    int sum = 0;
    for (auto &v: edges[u]) {
      memset(g, -1, sizeof(*g) * (sum + size[v] + 1));
      for (int i = 0; i <= sum; ++i) {
        for (int j = 0; j <= size[v]; ++j) {
          if (dp[v][j][0] != -1) upd(g[i + j], f[i] + dp[v][j][0]);
          if (dp[v][j][1] != -1) upd(g[i + j], f[i] + dp[v][j][1] + hp[v] * (!e));
        }
      }
      sum += size[v];
      memcpy(f, g, sizeof(i64) * (sum + 1));
    }
    for (int i = 0; i <= sum; ++i) {
      dp[u][i + e][e] = f[i] + e * delta;
    }
  }
}

int main() {
  int T;
  scanf("%d", &T);
  for (int cas = 1; cas <= T; ++cas) {
    int n;
    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
      edges[i].clear();
    }
    i64 sum = 0;
    for (int i = 1, p; i < n; ++i) {
      scanf("%d", &p);
      edges[p - 1].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
      scanf("%lld", &hp[i]);
      sum += hp[i];
      if (i) sum += hp[i];
    }
    dfs(0);
    for (int i = 0; i <= n; ++i) {
      if (i) putchar(' ');
      printf("%lld", sum - std::max(dp[0][i][0], dp[0][i][1]));
    }
    puts("");
  }
  return 0;
}
